using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace BrushesSample
{
    public partial class PathGradientClown : Form
    {
        public PathGradientClown()
        {
            InitializeComponent();
        }

        private void PathGradientClown_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int width = this.ClientRectangle.Width / 2;
            int height = this.ClientRectangle.Height / 2;

            Point[] triPoints = new Point[] { new Point(width/4, 0),
                                        new Point(0, height/2),
                                        new Point(width/2, height/2), };
            using (PathGradientBrush brush = new PathGradientBrush(triPoints))
            {
                brush.WrapMode = WrapMode.Tile;
                int x = 0;
                int y = 0;
                g.FillRectangle(brush, x, y, width, height / 2);
            }

            Point[] quadPoints = new Point[] { new Point(0, 0), 
                                         new Point(width, 0), 
                                         new Point(width, height), 
                                         new Point(0, height) };
            using (PathGradientBrush brush = new PathGradientBrush(quadPoints))
            {
                // defaults to Clamp, which won't draw anywhere except upper left of client
                //brush.WrapMode = WrapMode.Tile;
                int x = width;
                int y = 0;
                g.FillRectangle(brush, x, y, width, height);
            }

            Point[] diamondPoints = new Point[] { new Point(width / 2, 0), new Point(width, height / 2), new Point(width / 2, height), new Point(0, height / 2), };
            using (PathGradientBrush brush =
                     new PathGradientBrush(diamondPoints))
            {
                brush.WrapMode = WrapMode.Tile;
                brush.CenterPoint = new Point(0, height / 2);
                int x = 0;
                int y = height / 2 * 3;
                g.FillRectangle(brush, x, y, width, height / 2);
            }

            //      Point[] diamondPoints = new Point[] { new Point(width/2, 0), new Point(width, height/2), new Point(width/2, height), new Point(0, height/2), };
            //      using( GraphicsPath diamondPath = new GraphicsPath() ) {
            //        diamondPath.AddPolygon(diamondPoints);
            //        using( PathGradientBrush brush = new PathGradientBrush(diamondPath) ) {
            //          brush.WrapMode = WrapMode.Tile;
            //          int x = 0;
            //          int y = height;
            //          g.FillRectangle(brush, x, y, width, height);
            //        }
            //      }

            using (GraphicsPath circle = new GraphicsPath())
            {
                circle.AddEllipse(0, height/2, width, height);
                using (PathGradientBrush brush = new PathGradientBrush(circle))
                {
                    brush.WrapMode = WrapMode.Tile;
                    brush.SurroundColors = new Color[] { Color.Red }; // default
                    //brush.CenterColor = Color.Black;
                    if (ptCenter != Point.Empty) brush.CenterPoint = ptCenter;
                    ptCenter = Point.Round(brush.CenterPoint);
                    int x = 0;
                    int y = height/2;
                    g.FillRectangle(brush, x, y, width, height);
                }
            }
        }

        Point ptCenter = Point.Empty;
    }
}