using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.IO;

namespace ImagesSample {
  public partial class AnimatedCursorForm : Form {

    [DllImport("user32.dll")]
    static extern IntPtr LoadCursorFromFile(string lpFileName);
    
    static Cursor AnimatedCursor;
    
    static AnimatedCursorForm() {

      // Load animated cursor once for the lifetime of the applications
        String strCursor = @"..\..\..\..\ch05_DrawingBasics\ImagesSample\Resources\aero_busy.ani"; 
      if (!File.Exists(strCursor))
      { 
          throw new Exception("Cannot find file: " + Path.GetFullPath(strCursor)); 
      }
      IntPtr cursor = LoadCursorFromFile(strCursor);
      AnimatedCursor = new Cursor(cursor);
    }
    
    public AnimatedCursorForm() {
        InitializeComponent();
        this.Cursor = AnimatedCursor;
    }

  }
}