using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.IO;

namespace ImagesSample {
  public partial class ColoredCursorForm : Form {
  
    [DllImport("user32.dll")]
    static extern IntPtr LoadCursorFromFile(string lpFileName);

    static Cursor ColoredCursor;
    
    static ColoredCursorForm() {
      // Load colored cursor once for the lifetime of the application
        String strCursor = @"..\..\..\..\ch05_DrawingBasics\ImagesSample\Resources\aero_unavail_xl.cur";
        if (!File.Exists(strCursor))
        {
            throw new Exception("Cannot find file: " + Path.GetFullPath(strCursor));
        }
        IntPtr cursor = LoadCursorFromFile(strCursor);
      ColoredCursor = new Cursor(cursor);
    }
    
    public ColoredCursorForm() {
      InitializeComponent();
      this.Cursor = ColoredCursor;
    }

  }
}