using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace ImagesSample
{
    public partial class ScreenCopy : Form
    {
        public ScreenCopy()
        {
            InitializeComponent();
            panelIcon.Cursor = System.Windows.Forms.Cursors.Hand;
            
        }

        private void buttonCapture_Click(object sender, EventArgs e)
        {
            Rectangle screenRect = Screen.PrimaryScreen.WorkingArea;
            Bitmap dumpBitmap = new Bitmap(screenRect.Width, screenRect.Height);
            using (Graphics target = Graphics.FromImage(dumpBitmap))
            {
                //src x y; dest x y, size
                target.CopyFromScreen(
                    0, 0, 0, 0, new Size(dumpBitmap.Width, dumpBitmap.Height)
                    );
            }

            pictureBoxScreen.BackgroundImage = dumpBitmap;
            pictureBoxScreen.BackgroundImageLayout = ImageLayout.Stretch;
        }

        private void buttonForm_Click(object sender, EventArgs e)
        {
            Rectangle rect = new Rectangle(0, 0, this.Width, this.Height);
            Bitmap dumpBitmap = new Bitmap(rect.Width, rect.Height);
            this.DrawToBitmap(dumpBitmap, rect);

            pictureBoxScreen.BackgroundImage = dumpBitmap;
            pictureBoxScreen.BackgroundImageLayout = ImageLayout.Stretch;
        }

        private void buttonPanelIcon_Click(object sender, EventArgs e)
        {
            Rectangle rect = pictureBoxScreen.ClientRectangle;
            Bitmap bmpDump = new Bitmap(rect.Width, rect.Height);
            pictureBoxScreen.DrawToBitmap(bmpDump, rect);
            IntPtr hIcon = bmpDump.GetHicon();
            Icon iconNew = Icon.FromHandle(hIcon);
            //using (Graphics g = panelIcon.CreateGraphics())
            //{
            //    g.DrawIcon(iconNew, panelIcon.ClientRectangle);
            //}
            iconNew.Save(new FileStream("newIcon.ico", FileMode.Create, FileAccess.Write));
            this.Icon = iconNew;
        }

        private void buttonNap_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.No;
            Thread.Sleep(3000);
        }
    }
}