﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace PensSample {
  partial class LineCapsForm : Form {
    public LineCapsForm() {
      InitializeComponent();
    }

    private void LineCapsForm_Paint(object sender, PaintEventArgs e) {
      Graphics g = e.Graphics;
      string[] capNames = Enum.GetNames(typeof(LineCap));
      Array.Sort(capNames);

      int x = 0;
      int y = 0;
      int width = this.ClientRectangle.Width / 2;
      int height = this.ClientRectangle.Height / (((capNames.Length) / 2));
      Brush blackBrush = Brushes.Black;
      Pen whitePen = System.Drawing.Pens.White;

      foreach( string capName in capNames ) {
          using (Pen pen = new Pen(Color.Black, 12))
          using (GraphicsPath path = new GraphicsPath())
          //using (GraphicsPath pathFill = new GraphicsPath())
          {
          pen.EndCap = (LineCap)Enum.Parse(typeof(LineCap), capName);          
          if( pen.EndCap == LineCap.AnchorMask ) continue; // Not a real LineCap
          if( pen.EndCap == LineCap.Custom ) {
              // width and height of 3 and unfilled arrow head
              //path.AddLine(0, 0, 2, -2);
              //path.AddLine(0, 0, -2, -2);
              //path.AddEllipse(-2, -2, 4, 4);
              path.AddPie(new Rectangle(-1, -1, 2, 2), -90f, 180f);
              //path.AddPie(new Rectangle(-1, -1, 4, 9), 0f, 180f);
              pen.CustomEndCap = new CustomLineCap(null, path);
              //pen.CustomEndCap = new AdjustableArrowCap(3f, 3f, false);
              pen.DashStyle = DashStyle.Dash;
              pen.DashCap = DashCap.Triangle;
          }
          g.DrawLine(pen, x, y + height * 2 / 3, x + width * 2 / 3, y + height * 2 / 3);
          g.DrawLine(whitePen, x, y + height * 2 / 3, x + width * 2 / 3, y + height * 2 / 3);
          g.DrawString(capName, this.Font, blackBrush, x, y);
          x += width;
          if( x > this.ClientRectangle.Width - width ) {
            y += height;
            x = 0;
          }
        }
      }
    }
  }
}