﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace ShapesSample {
  partial class CurvesForm : Form {
    public CurvesForm() {
      InitializeComponent();
    }

    private void CurvesForm_Paint(object sender, PaintEventArgs e) {
    }

    float fDynamicTension = 1.0f;
    private void toolDynamicTension_TextChanged(object sender, EventArgs e)
    {
         float.TryParse(toolDynamicTension.Text, out fDynamicTension);
         this.Invalidate(true);
    }

    private void panelDraw_Paint(object sender, PaintEventArgs e)
    {

        Graphics g = e.Graphics;
        int x = 0;
        int y = 0;
        int width = this.ClientRectangle.Width / 3;
        int height = this.ClientRectangle.Height;
        Brush blackBrush = Brushes.Black;
        Brush fillBrush = Brushes.Gray;
        Pen whitePen = System.Drawing.Pens.White;
        StringFormat format = new StringFormat();
        format.Alignment = StringAlignment.Center;
        format.LineAlignment = StringAlignment.Far;
        int fontHeight = this.Font.Height;

        using (Pen pen = new Pen(Color.Red, 4))
        using (Pen pointPen = new Pen(Color.Black, 3))
        {
            pointPen.StartCap = pointPen.EndCap = LineCap.SquareAnchor;

            float tension = 0;
            Point[] points = null;

            // Render 4-point curve with tension 0
            tension = 0.0f;
            points = new Point[] { new Point(x + 25, y + height - fontHeight - 10 - 25), new Point(x + width - 25, y + height - fontHeight - 10 - 25), new Point(x + 25, y + 25), new Point(x + width - 25, y + 25), };
            g.DrawCurve(pen, points, tension);
            g.DrawRectangle(Pens.Black, x, y, width, height - fontHeight - 10);
            foreach (Point point in points) g.DrawLine(pointPen, new Point(point.X, point.Y), new Point(point.X + 1, point.Y));
            for (int i = 0; i != points.Length; ++i) g.DrawString(i.ToString(), this.Font, blackBrush, points[i]);
            g.DrawString(string.Format("Tension= {0}", tension), this.Font, blackBrush, new Rectangle(x, y, width, height - 5), format);
            x = (x > this.ClientRectangle.Width - 2 * width ? 0 : x + width);
            y = (x == 0 ? y + height - fontHeight - 10 : y);

            // Render 4-point curve with tension 0.5
            tension = 0.5f;
            points = new Point[] { new Point(x + 25, y + height - fontHeight - 10 - 25), new Point(x + width - 25, y + height - fontHeight - 10 - 25), new Point(x + 25, y + 25), new Point(x + width - 25, y + 25), };
            g.DrawRectangle(Pens.Black, x, y, width, height - fontHeight - 10);
            g.DrawCurve(pen, points, tension);
            foreach (Point point in points) g.DrawLine(pointPen, new Point(point.X, point.Y), new Point(point.X + 1, point.Y));
            for (int i = 0; i != points.Length; ++i) g.DrawString(i.ToString(), this.Font, blackBrush, points[i]);
            g.DrawString(string.Format("Tension= {0}", tension), this.Font, blackBrush, new Rectangle(x, y, width, height - 5), format);
            x = (x > this.ClientRectangle.Width - 2 * width ? 0 : x + width);
            y = (x == 0 ? y + height - fontHeight - 10 : y);

            // Render 4-point curve with dynamic tension
            points = new Point[] { new Point(x + 100, y + height - fontHeight - 10 - 100), new Point(x + width - 100, y + height - fontHeight - 10 - 100), new Point(x + 100, y + 100), new Point(x + width - 100, y + 100), };
            g.DrawRectangle(Pens.Black, x, y, width, height - fontHeight - 10);
            g.DrawCurve(pen, points, fDynamicTension);
            foreach (Point point in points) g.DrawLine(pointPen, new Point(point.X, point.Y), new Point(point.X + 1, point.Y));
            for (int i = 0; i != points.Length; ++i) g.DrawString(i.ToString(), this.Font, blackBrush, points[i]);
            g.DrawString(string.Format("Tension= {0}", fDynamicTension), this.Font, blackBrush, new Rectangle(x, y, width, height - 5), format);
            x = (x > this.ClientRectangle.Width - 2 * width ? 0 : x + width);
            y = (x == 0 ? y + height - fontHeight - 10 : y);
        }
    }

    private void resizeRedrawToolStripMenuItem_Click(object sender, EventArgs e)
    {
        this.SetStyle(ControlStyles.ResizeRedraw, !this.GetStyle(ControlStyles.ResizeRedraw));
        ((ToolStripMenuItem)sender).Checked = this.GetStyle(ControlStyles.ResizeRedraw);
    }

    private void panelDraw_Resize(object sender, EventArgs e)
    {
        if (invalidateResizeToolStripMenuItem.Checked)
        {
            Invalidate(true);
        }
    }

    private void invalidateResizeToolStripMenuItem_Click(object sender, EventArgs e)
    {
        ToolStripMenuItem item = (ToolStripMenuItem)sender;
        item.Checked = !item.Checked;
    }


  }
}