using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace ShapesSample
{
    public partial class RestoreGraphics : Form
    {
        public RestoreGraphics()
        {
            InitializeComponent();
        }

        private void RestoreGraphics_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            DrawRotatedString(g);
            g.DrawString("This is not rotated", this.Font, Brushes.Blue, 100, 100);
        }

        private void DrawRotatedString(Graphics g)
        {
            GraphicsState stateSaved = g.Save();
            if (checkBoxRotate.Checked)
            {
                g.RotateTransform(45f);
            }
            g.DrawString("This is rotated", this.Font, Brushes.Blue, 0, 0);
            if (checkBoxRestore.Checked)
            {
                g.Restore(stateSaved);
            }
        }

        private void checkBoxRotate_CheckedChanged(object sender, EventArgs e)
        {
            Invalidate(true);
        }

        private void checkBoxRestore_CheckedChanged(object sender, EventArgs e)
        {
            Invalidate(true);
        }
    }
}